dojo.provide("com.ibm.ccl.welcome.widget.DynamicContent");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.cookie");

dojo.declare("com.ibm.ccl.welcome.widget.DynamicContent", [ dijit._Widget, dijit._Templated ], {
    templateString: "<div dojoAttachPoint=\"mainNode\"></div>",
    sectionid: "",
    constructor: function () {
        // this runs when you widget is first instantiated
       
    },
    postCreate: function () {
        // this runs after the template DOM nodes have been created
       
        var jsonObj;
        
        var sectionID = this.sectionid;
        
        var widgetRef = this;
       
        //Get welcome preference
        var welcomeData="";
        
        var appURL = window.location.href;
		var appHost = window.location.host;
		var hostIndex = appURL.indexOf(appHost);
		var nextSlashIndex = appURL.indexOf('/',hostIndex+1);
		var endSlashIndex = appURL.indexOf('/',nextSlashIndex+1);
		var appContext = appURL.substring(nextSlashIndex+1,endSlashIndex);
		
		var dynamicURL = "/"+appContext+"/dynamic/dynamicWelcomeRetriever";	
		
		/*var pingHelpJFSURL = "/"+appContext+"/dynamic/pingHelpJFS";
		
		dojo.xhrGet({
			url: pingHelpJFSURL,
			handleAs: "text",
			content: {
				
			},
			load: function(data) {
				
				if(data=="true")
				{
					dojo.xhrGet({
						url: '/helpjfs/welcome?welcomeOperation=welcomeLoad',
						handleAs: "text",
						content: {
					
						},
						load: function(data) {
					
							welcomeData = data+"";
					
						},
						error: function() {
					
						}
					});
				}
			},
			error: function() {
				
			}
		});
		*/
		
		//Call Cookie service and set welcomeData (Ex: GeneralInformation,RationalTeamConcert
		welcomeData = dojo.cookie("welcomeData");
		
		 dojo.xhrGet({
			url: dynamicURL,
					handleAs: "json",
						content: {
					 		key:welcomeData,
							sectionID:sectionID
						},
						load: function(data) {
						
							jsonObj = data;
							widgetRef.mainNode.appendChild(widgetRef.convertJSONToHTML(jsonObj,sectionID));
						},
						error: function(data) {
						
						}
			});
    },
    
    convertJSONToHTML: function(obj,thisSection) {
        var mainDiv = document.createElement("div");
    	
    	var divContent="";
    	
    	var entry;
	    var currLink;
	    var currLinkTitle;
	    var currLinkDescription;
	    var currLinkImage;
	    	
    	if(thisSection!="capabilities")
    	{
	    	divContent ="<ul>";
	    	 	
	    	for (var i = 0; i < obj.items.length; i++){
	            entry = obj.items[i];
	            currLink = entry.link;
	            currLinkTitle = entry.linktitle;
	            currLinkDescription = entry.linkdescription;
	            currLinkImage = entry.linkimage;
	            
	            divContent = divContent + "<li>";
	            divContent = divContent + "<a target=\"blank\" href=\""+currLink+"\">";
	            divContent = divContent + currLinkTitle;
	            divContent = divContent + "</a>";
	            divContent = divContent + "</li>";
	        }
	
	    	
	    	//Build divContent based on json obj
	    	divContent = divContent + "</ul>";
        }
        else
        {
        	for (var i = 0; i < obj.items.length; i++){
	            entry = obj.items[i];
	            currLink = entry.link;
	            currLinkTitle = entry.linktitle;
	            currLinkDescription = entry.linkdescription;
	            currLinkImage = entry.linkimage;
	            
	            divContent = divContent + "<div class=\"capability1ColumnLeft\">";
				divContent = divContent + "<div style=\"top:3px\"><img src=\""+currLinkImage+"\" height=\"36px\" width=\"30px\"/></div></div>";
				divContent = divContent + "<div class=\"capability1ColumnRight\">";
				divContent = divContent + "<div class=\"capabilityTitle\"><a  href=\""+currLink+"\" target=\"blank\">"+currLinkTitle+"</a></div>";
				divContent = divContent + "<div class=\"capabilityText\">"+currLinkDescription+"</div></div>";
	        }
        }
        // Populate the div according to json obj
        mainDiv.innerHTML=divContent;
       
        return mainDiv;
    },
	refresh: function() {
		
		var mainDiv = this.mainNode.childNodes[0];
		var thisSection = this.sectionid;
		var widgetRef = this;
		
		var welcomeData="";
		var loadedJFS="false";
		
		var appURL = window.location.href;
		var appHost = window.location.host;
		var hostIndex = appURL.indexOf(appHost);
		var nextSlashIndex = appURL.indexOf('/',hostIndex+1);
		var endSlashIndex = appURL.indexOf('/',nextSlashIndex+1);
		var appContext = appURL.substring(nextSlashIndex+1,endSlashIndex);
		
		var dynamicURL = "/"+appContext+"/dynamic/dynamicWelcomeRetriever?defaultToken=false";	
		
		/*var pingHelpJFSURL = "/"+appContext+"/dynamic/pingHelpJFS";
		
		dojo.xhrGet({
			url: pingHelpJFSURL,
			handleAs: "text",
			content: {
				
			},
			load: function(data) {
				
				if(data=="true")
				{
					dojo.xhrGet({
						url: '/helpjfs/welcome?welcomeOperation=welcomeLoad',
						handleAs: "text",
						content: {
							
						},
						load: function(data) {
							
							welcomeData = data+"";
							loadedJFS="true";
						},
						error: function() {
							
						}
					});
				}
			},
			error: function() {
				
			}
		});
		*/
		
		var formChildren = dijit.byId("welcomeCustomizationForm").getChildren();
		var currChild;
		var currCheckboxID;
		var currCheckedValue;
		var currChildName;
		var checkboxIndex;
		var currLabelID;
		var currLabelValue;
		var i = 0;
		var newPrefString="";
		
		for (i = 0; i < formChildren.length; i++)
		{
			currChild = formChildren[i];
			currCheckboxID = currChild.id;
			
			currCheckedValue = dijit.byId(currCheckboxID).getValue();
			
			if (currCheckedValue)
			{
				checkboxIndex = currCheckboxID.indexOf("_checkbox");
				currChildName = currCheckboxID.substring(0, checkboxIndex);
				
				if (newPrefString != "")
					newPrefString = newPrefString + ",";
				
				newPrefString = newPrefString + currChildName;
			}
		}
		
		welcomeData = newPrefString;
		
		dojo.xhrGet({
			url: dynamicURL,
			handleAs: "json",
			content: {
				key: welcomeData,
				sectionID: thisSection
			},
			load: function(data) {
				jsonObj = data;
				widgetRef.updateJSONToHTML(jsonObj,thisSection,mainDiv);
			},
			error: function(data) { }
		});
	},
	
	updateJSONToHTML: function(obj,thisSection,mainDiv) {
		// var mainDiv = document.createElement("div");
    	 
    	var divContent="";
    	
    	var entry;
	    var currLink;
	    var currLinkTitle;
	    var currLinkDescription;
	    var currLinkImage;
	    	
    	if(thisSection!="capabilities")
    	{
	    	divContent ="<ul>";
	    	 	
	    	for (var i = 0; i < obj.items.length; i++){
	            entry = obj.items[i];
	            currLink = entry.link;
	            currLinkTitle = entry.linktitle;
	            currLinkDescription = entry.linkdescription;
	            currLinkImage = entry.linkimage;
	            
	            divContent = divContent + "<li>";
	            divContent = divContent + "<a target=\"blank\" href=\""+currLink+"\">";
	            divContent = divContent + currLinkTitle;
	            divContent = divContent + "</a>";
	            divContent = divContent + "</li>";
	        }
	
	    	
	    	//Build divContent based on json obj
	    	divContent = divContent + "</ul>";
        }
        else
        {
        	for (var i = 0; i < obj.items.length; i++){
	            entry = obj.items[i];
	            currLink = entry.link;
	            currLinkTitle = entry.linktitle;
	            currLinkDescription = entry.linkdescription;
	            currLinkImage = entry.linkimage;
	            
	            divContent = divContent + "<div class=\"capability1ColumnLeft\">";
				divContent = divContent + "<div><img src=\""+currLinkImage+"\" height=\"36px\" width=\"30px\"/></div></div>";
				divContent = divContent + "<div class=\"capability1ColumnRight\">";
				divContent = divContent + "<div class=\"capabilityTitle\"><a  href=\""+currLink+"\" target=\"blank\">"+currLinkTitle+"</a></div>";
				divContent = divContent + "<div class=\"capabilityText\">"+currLinkDescription+"</div></div>";
	        }
        }
        // Populate the div according to json obj
        mainDiv.innerHTML=divContent;
       
       // return mainDiv;
    }
});