// Note: This script gets its localized message using the following link.  It must be included
// in any jsp files using this script:
// <script type="text/javascript" src="../com.ibm.remote.configuration.servlets.TranslationsService/com.ibm.remote.configuration.utils.Messages.js?lang=<%=lang%>"></script>


function initICDialog() {
	dijit.byId("icname").validator = function (value, constraints) {
		
		var url = dojo.byId("icurl").value;
		
		var isValidName = value.match("[^,]+") != null;
		var isValidURL = url.match("[^,]+\://[^,]+/[^,]+") != null;
		
		setAttribute('ICOKButton', 'disabled', (!isValidName || !isValidURL));
		
		return isValidName;
	}
	
	dijit.byId("icurl").validator = function (value, constraints) {
		
		var name = dojo.byId("icname").value;
		
		var isValidName = name.match("[^,]+") != null;
		var isValidURL = value.match("[^,]+\://[^,]+/[^,]+") != null;
		
		setAttribute('ICOKButton', 'disabled', (!isValidName || !isValidURL));
		setAttribute('ICTestButton', 'disabled', (!isValidURL));
		
		return isValidURL;
	}
}

function validateDialog() {
	
	var name = dojo.byId("icname").value;
	var url = dojo.byId("icurl").value;
	var errorMsg = '';
	
	var isValidName = name.search(/[^,]+$/) == 0;
	var isValidURL = url.search(/[^,]+\:\/\/[^,]+\/[^,]+$/) == 0;
	
	setAttribute('ICOKButton', 'disabled', (!isValidName || !isValidURL));
	setAttribute('ICTestButton', 'disabled', (!isValidURL));
}

function handleICDialogClose() {
	
	// reset dislog controls, cancel any async calls
	if (_xhrHandler) {
        _xhrHandler.cancel();
        _xhrHandler = null;
    }
	
	setAttribute('ICOKButton', 'disabled', true);
	setAttribute('ICTestButton', 'disabled', true);
	
	document.getElementById('status').innerHTML = '';
	document.getElementById('waitbar').style.display = 'none';
	
	dijit.byId('ICDialog').hide();
}

function handleDeleteICDialogClose() {
	
	dijit.byId('deleteICDialog').hide();
}

function addICDialog() {
	// Clear all fields
	dojo.byId("icname").value = "";
	dojo.byId("icname").op = "add";
	dojo.byId("icurl").value = "";
	
	var title = AddICDialog_2_msg;
	dijit.byId("ICDialog").setTitle(title);
	dijit.byId("ICDialog").show();
}

function addIC() {
	var name = dojo.byId("icname").value;
	var href = fixHref(dojo.byId("icurl").value);
	
	var row = {
		"uid" : remoteHelpStore._arrayOfAllItems.length,
		"name" : name,
		"href" : href,
		"enabled" : "true"
	};
	remoteHelpStore.newItem(row);
	handleICDialogClose();
	dirty = true;
	updateButtonStates();
}

function editICDialog() {

	var item = remoteHelpGrid.selection.getSelected()[0];
				
	dojo.byId("icname").value = remoteHelpStore.getValue(item, "name");
	dojo.byId("icname").op = "edit";
	dojo.byId("icurl").value = remoteHelpStore.getValue(item, "href");
	
	var title = format(EditICDialog_7_msg, remoteHelpStore.getValue(item, "name"));
	dijit.byId("ICDialog").setTitle(title);
	dijit.byId("ICDialog").show();
}

function editIC() {
	var name = dojo.byId("icname").value;
	var href = fixHref(dojo.byId("icurl").value);
	var index = remoteHelpGrid.selection.selectedIndex;
	
	var item = remoteHelpGrid.selection.getSelected()[0];
	var state = remoteHelpStore.getValue(item,"enabled");
	
	remoteHelpStore.setValue(item, "name", name);
	remoteHelpStore.setValue(item, "href", href);
	remoteHelpStore.setValue(item, "enabled",state);
	
	handleICDialogClose();
	dirty = true;
	updateButtonStates();
}

function testICDialog() {

	editICDialog();
	testConnection();
}

function fixHref(href)
{
	if (href.indexOf("/index.jsp")>-1)
		href = href.substring(0,href.indexOf("/index.jsp"));
	else if (href.indexOf("/site/site.xml")>-1)
		href = href.substring(0,href.indexOf("/site/site.xml"));
		
	return href;
}

function testConnection()
{
	// disable Test Connection button
	setAttribute('ICTestButton', 'disabled', true);
	setAttribute('ICOKButton', 'disabled', true);
	setAttribute('ICCancelButton', 'disabled', true);
	
	document.getElementById("status").innerHTML = '';
	waitbar.update({indeterminate: true});
	document.getElementById("waitbar").style.display = 'block';

	var href = fixHref(dojo.byId("icurl").value);
	
	dojo.xhrGet( {
		url : 'testConnection',
		handleAs : "text",
		content : {
			href : href
		},
		load : function(data) {
			setAttribute('ICTestButton', 'disabled', false);
			setAttribute('ICOKButton', 'disabled', false);
			setAttribute('ICCancelButton', 'disabled', false);

			if (data == "success")
				document.getElementById("status").innerHTML = '<img src="icons/info.gif" style="position:relative;top:3px;" alt=""/> ' + TestConnectionDialog_12_msg;
			else
				document.getElementById("status").innerHTML = '<img src="icons/error.gif" style="position:relative;top:3px;" alt=""/> ' + TestConnectionDialog_13_msg;
				
			document.getElementById("waitbar").style.display = 'none';
		},
		error: function(args) {

			setAttribute('ICTestButton', 'disabled', false);
			setAttribute('ICOKButton', 'disabled', false);
			setAttribute('ICCancelButton', 'disabled', false);
			
            document.getElementById("status").innerHTML = '<img src="icons/error.gif" style="position:relative;top:3px;" alt=""/> ' + TestConnectionDialog_13_msg;
        }
	});
}

//Deleting an item from the grid
function deleteICsDialog() {
	
	var items = remoteHelpGrid.selection.getSelected();
	var list = '';
	for (var i=0; i<items.length; i++)
	{
		if (items.length > 1) {
			list += '<br/>'
		}
		list += remoteHelpStore.getValue(items[i], "name");
	}
								
	//Set title to delete div
	var name = '';
	if (items.length == 1) {
		name = list;
	}
	var title = format(HelpContentBlock_rmvTitle_msg, name);
	dijit.byId("deleteICDialog").setTitle(title);
	
	//Set the name in the delete dialog
	var label = format(HelpContentBlock_rmvLabel_msg, list);
	dojo.byId("deleteICLabel").innerHTML = label;
	
	dijit.byId("deleteICDialog").show();
}

function deleteICs() {
			
	var items = remoteHelpGrid.selection.getSelected();
	
	for (var i=0;i<items.length;i++)
	{
		var thisRemoteID = remoteHelpStore.getValue(items[i], "uid");
		remoteHelpStore.fetchItemByIdentity({
	    	identity: thisRemoteID,
	    	onItem : function(item) {
				remoteHelpStore.deleteItem(item);
			}
		});
	}

	handleDeleteICDialogClose();
	dirty = true;
	updateButtonStates();
}

// Format string with replacement variables
function format(str) {
	
	for(i = 1; i < arguments.length; i++) {
		str = str.replace("{" + (i - 1) + "}", arguments[i]);
	}
	return str;
}

function setAttribute(dijitId, property, value) {
	
	var dijitObject = dijit.byId(dijitId);
	if (dijitObject)
		dijitObject.attr(property, value);
}

function setNodeAttribute(nodeId, property, value) {
	
	dojo.attr(nodeId, property, value);
}

function localOnly() {
	//IE dims everything fine, but the buttons still clickable, nothing happens FF
	//dojo.byId("layoutTable").setAttribute('disabled', true);
	
	//Just for the grid
	//TODO: GRID DISABLING
	//setAttribute('remoteHelpGrid', 'disabled', true);
	
	setAttribute('New', 'disabled', true);
	setAttribute('restore_defaults', 'disabled', true);
	
	setAttribute('Edit', 'disabled', true);
	setAttribute('Delete', 'disabled', true);
	setAttribute('ViewProperties', 'disabled', true);
	setAttribute('TestConnection', 'disabled', true);
	setAttribute('Enable', 'disabled', true);
	setAttribute('Up', 'disabled', true);
	setAttribute('Down', 'disabled', true);
	
	var remoteHelpType = "localOnly";
	
	dojo.xhrGet( {
			url : 'toggleRemoteHelpType',
			handleAs : "text",
			content : {
				remoteHelpType: remoteHelpType
			},
			load : function(data) {
				
				
			},
			error : function(data) {

			}

		});
	
}

function remote() {
	//Just for the grid
	//TODO: GRID DISABLING
	//setAttribute('remoteHelpGrid', 'disabled', false);
	
	setAttribute('New', 'disabled', false);
	setAttribute('restore_defaults', 'disabled', false);
	
	var remoteHelpType = "remotePreferred";
	
	dojo.xhrGet( {
		url : 'toggleRemoteHelpType',
		handleAs : "text",
		content : {
			remoteHelpType: remoteHelpType
		},
		load : function(data) {
			
		},
		error : function(data) {
			
		}
	});
}

function updateButtonStates()
{
	var firstIC = remoteHelpGrid.selection.getSelected()[0];
	if (firstIC!=null)
	{
	
		var index = remoteHelpGrid.selection.selectedIndex;
		setAttribute('Delete', 'disabled', false);
		setAttribute('Enable', 'disabled', false);
		if(remoteHelpStore.getValue(firstIC, "enabled")=="true")
		{
			setAttribute('Enable', 'label', disable);
		}
		else
		{
			setAttribute('Enable', 'label', enable);
		}
		
		if (remoteHelpGrid.selection.getSelected().length==1)
		{
			setAttribute('Edit', 'disabled', false);
			setAttribute('TestConnection', 'disabled', false);
			setAttribute('Up', 'disabled', index==0);
			setAttribute('Down', 'disabled', index==remoteHelpGrid.rowCount-1);		
		}
		else
		{
			setAttribute('Edit', 'disabled', true);
			setAttribute('TestConnection', 'disabled', true);
			setAttribute('Up', 'disabled', true);
			setAttribute('Down', 'disabled', true);		
		}
	}		
	else
	{
		setAttribute('Edit', 'disabled', true);
		setAttribute('TestConnection', 'disabled', true);
		setAttribute('Up', 'disabled', true);
		setAttribute('Down', 'disabled', true);		
		setAttribute('Delete', 'disabled', true);
		setAttribute('Enable', 'disabled', true);	
	}
	
	setAttribute('Apply','disabled',!dirty);
}

function move(direction)
{
	var row = remoteHelpGrid.selection.selectedIndex;
	
	var index = row;
	var offset = 1;

	if (direction=='up')
	{
		index = 0-row;
		offset = -1;
	}
	
	swap(row,row+offset);
	remoteHelpGrid.selection.clear();
	remoteHelpGrid.selection.setSelected(row+offset,true);
	updateButtonStates();
}

function swap(index1,index2)
{	
	var items = remoteHelpStore._arrayOfAllItems;
	
	var item1 = items[index1];
	var item2 = items[index2];
	
	var name1 = item1.name;
	var href1 = item1.href;
	var enabled1 = item1.enabled;
	
	var item1ID = item1.uid;
	remoteHelpStore.fetchItemByIdentity({
		identity: item1ID,
		onItem : function(item) {	
			remoteHelpStore.setValue(item,"name",item2.name);
			remoteHelpStore.setValue(item,"href",item2.href);
			remoteHelpStore.setValue(item,"enabled",item2.enabled);
		}
	});
	
	
	var item2ID = item2.uid;
	remoteHelpStore.fetchItemByIdentity({
		identity: item2ID,
		onItem : function(item) {	
			remoteHelpStore.setValue(item,"name",name1);
			remoteHelpStore.setValue(item,"href",href1);
			remoteHelpStore.setValue(item,"enabled",enabled1);
		}
	});
	
	dirty = true;
}

//the Restore default
function restoreDefaults() 
{
	//Call remote retriever for defaults.  That will handle set back.
	dojo.xhrGet({
		url: '../com.ibm.ut.common.ic.ConnectionService/DEFAULTS',
		handleAs: "json",
		load: function(data, ioArgs) {

			remoteHelpStore.fetch({
		    	query: {uid:'*'},
		    	onItem : function(item) {
					remoteHelpStore.deleteItem(item);
				}
			});

			for (var i=0;i<data.items.length;i++)
			{
				var row = {
					"uid" : data.items[i].uid,
					"name" : data.items[i].name,
					"href" : data.items[i].href,
					"enabled" : data.items[i].enabled
				};
				remoteHelpStore.newItem(row);
			}
			
//			remoteHelpGrid.setStore(remoteHelpStore, {uid: '*'});
			
			dirty = true;
			updateButtonStates();
		}
	});
}

function apply()
{
	remoteHelpStore.save({onComplete:function(){}});
	dirty = false;
	updateButtonStates();
}

function handleEnableDisable()
{
	var items = remoteHelpGrid.selection.getSelected();

	// First update toggle the button text

	var button = dijit.byId('Enable'); 
	var bText = button.label;
	
	for (var i=0;i<items.length;i++)
	{
		var state = "false";
		
		if (bText.indexOf(enable)>-1)
			state = "true";
		
		var uid = remoteHelpStore.getValue(items[i], "uid");
		remoteHelpStore.fetchItemByIdentity({
	    	identity: uid,
	    	onItem : function(item) {	    	
	       		 remoteHelpStore.setValue(item, "enabled", state);
	   		}
		});
	}
	dirty = true;
	updateButtonStates();
}


function ok(type)
{
	var field = dojo.byId("icname");

	if (field.op == "add") {
		addIC();
	} else {
		editIC();
	}

}
