
function initAddSitesDialog() {
	
	//createOptionsDialog();
	
	dojo.connect(dojo.byId("localType"),  "onclick", function () {
		if (IS_VIEW_EDIT_MODE == true && VIEW_SITE_TYPE == true) {
			updateSiteDialog(VIEW_SITE_NAME, VIEW_SITE_TYPE, VIEW_SITE_PATH);
		} else {
			updateSiteDialog(dojo.byId('sitename').value, true, '');
		}
	});
	
	dojo.connect(dojo.byId("remoteType"),  "onclick", function() {
		if (IS_VIEW_EDIT_MODE == true && VIEW_SITE_TYPE == false) {
			updateSiteDialog(VIEW_SITE_NAME, VIEW_SITE_TYPE, VIEW_SITE_PATH);
		} else {
			updateSiteDialog(dojo.byId('sitename').value, false, 'http://');
		}
	});
	
	dojo.connect(dojo.byId("remoteType"),  "onfocus", function() {
		createLocalTooltip();
	});
	
	dojo.connect(dojo.byId("cancelSiteXMLUploadButton"),  "onfocus", function() {
		createLocalTooltip();
	});
	
	dojo.connect(dojo.byId("localType"),  "onmouseover", function() {
		createLocalTooltip();
		var currTooltip = dijit.byId('local_tooltip');
		if (currTooltip != undefined) {
			currTooltip.open();
		}
	});
	
	dojo.connect(dijit.byId('optionsDialog'), "hide", handleLocalCancel);
	
	dijit.byId("internalFile").validator = function (value, constraints) {
	
		dojo.byId("helpButton").style.display = 'none';
		
		var valid = value.match("[/\\\\]site\.xml$") != null;
		
		var siteName = dijit.byId('sitename').textbox.value;
		var notEmpty = siteName != "";
		
		// If not modified, return
		if (!isSiteinfoModified(siteName, value)) {
			
			setAttribute('okSiteXMLUploadButton', 'disabled', true);
			return valid;
		}
		
		var dijitInternalFile = dijit.byId("internalFile");
		dijitInternalFile.invalidMessage = siteXMLErrorlbl_msg;
		
		var isLocalType = dijit.byId("localType").getValue();
		if (isLocalType != false) {
			if (value == "C:\\fakepath\\site.xml" && isIE8()) {
				dijitInternalFile.invalidMessage = siteXMLWarninglbl_msg;
				dojo.byId("helpButton").style.display = 'block';
				setAttribute('okSiteXMLUploadButton', 'disabled', false);
				return false;
			}
		}
		
		setAttribute('okSiteXMLUploadButton', 'disabled', (!valid || !notEmpty));
		
		return valid;
	}
	
	dijit.byId("sitename").validator = function (value, constraints) {
	
		var notEmpty = value != "";
		
		var siteFile = dijit.byId('internalFile').textbox.value;
		// If not modified, return
		if (!isSiteinfoModified(value, siteFile)) {
			
			setAttribute('okSiteXMLUploadButton', 'disabled', true);
			return notEmpty;
		}
		
		var valid = dijit.byId("internalFile").isValid();
		setAttribute('okSiteXMLUploadButton', 'disabled', (!valid || !notEmpty));						
		return notEmpty;
	}
}

function isFileExists(filePath) {
	
	var isExists = false;
	if (isIE()) {
		try {
			var fso = new ActiveXObject("Scripting.FileSystemObject");
			isExists = fso.FileExists(filePath);
		} catch(e) {}
	} else if (isFireFox()) {
		try {
			netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		} catch (e) {
			alertError(errorFFBrowserSecuritylbl_msg);
			return false;
		}
		var file = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath(filePath);
		return file.exists();
	}
	
	return isExists;
}

function readFileNameFirefox(fileBrowser) {
	
	try {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	} catch (e) {
		updateFileSelectionControl(true);
		alertError(errorFFBrowserSecuritylbl_msg);
		return "";
	}
	var file = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
	file.initWithPath(fileBrowser.value);
	
	return fileBrowser.value;
}

function readFileNameIE(fileBrowser) {
	
	var fileName = '' + fileBrowser.value;
	if (fileName.indexOf("\\") < 0 || fileName == "C:\\fakepath\\site.xml") {
		try {
			var fso = new ActiveXObject("Scripting.FileSystemObject");
			if (fileName.indexOf("\\") < 0)
				fileName = fso.GetAbsolutePathName(fileName);
		}
		catch(e) {
			updateFileSelectionControl(true);
			if (e.number == -2146827859) {
				// This is what we get if the browser's security settings forbid
				// the use of the FileSystemObject ActiveX control...
				alertError(errorIEBrowserSecuritylbl_msg);
				return "";
			}
			else if (e.number == -2146828218) {
				// This is what we get if the browser can't access the file
				// because of file permissions...
				alertError(format(errorNoFilePermission_msg, fileName));
				return "";
			}
			else
				throw e;
		}
	}
	
	return fileName;
}

function readSiteFileNameForLocal(fileBrowser) {
	
	var siteFile = fileBrowser.value;
	
	if (siteFile == "") return "";	// No site.xml file selected
	
	var ua = navigator.userAgent;
//	alert(ua);
	if (isIE8())
		siteFile = readFileNameIE(fileBrowser);
	else if (isFireFox3())
		siteFile = readFileNameFirefox(fileBrowser);
	
	return siteFile;
}

function isIE8() {
	
	var ua = navigator.userAgent;
	if (isIE()) {
		var versionIE = ua.charAt(ua.indexOf("MSIE")+5);
		if (isIE && versionIE >= 7) {
			// the browser claims to be IE 7 or new, 
			// and is not Opera, Safari or iCab
			if (ua.indexOf("Trident")!=-1 	// IE 8 beta
					|| versionIE >= 8)		// IE 8 onwards
				return true;
		}
	}
	
	return false;
}

function isIE() {
	
	var isIE = false;
	var ua = navigator.userAgent;
	if (ua.indexOf("MSIE")!=-1 && ua.indexOf('Opera') == -1) {
		isIE = true;
		if (ua.indexOf('Windows NT 5.2') != -1 && ua.indexOf('.NET CLR') == -1)
			isIE = false;
	}
	return isIE;
}

function isFireFox3() {
	var ua = navigator.userAgent;
	return (isFireFox() && ua.charAt(ua.indexOf("Firefox/")+8) > 2);
}

function isFireFox() {
	
	var ua = navigator.userAgent;
	return (!(ua.indexOf("MSIE")!=-1 && ua.indexOf('Opera') == -1) && (ua.indexOf("Firefox/") != -1));
}

function readSiteXMLFullFileName() {
	
	var fileBrowser = dijit.byId('localFile');
	var isLocalType = dijit.byId("localType").getValue();
	var siteFile = "";
	
	if (isLocalType != false)
		siteFile = readSiteFileNameForLocal(fileBrowser.fileInput);
	else
		siteFile = fileBrowser.value;
	
	if (siteFile == "" || siteFile == "http://") return "";	// No site.xml file selected
	
	return siteFile;
}

function readSiteXMLFileName(fileid) {
	
	var fileBrowser = dijit.byId(fileid);
	var isFileType = ('localFile' == fileid);
	var siteFile = "";
	
	if (isFileType == true)
		siteFile = fileBrowser.fileInput.value;
	else
		siteFile = fileBrowser.value;
	
	return siteFile;
}

function showIEFakepathHelp() {
	
	alertWithTitle(errorIEBrowserIntranetSecuritylbl_msg, 
			infolbl_msg);
}

/**************************************************************
* Ensures that the file that will be uploaded will strictly be 
* a site.xml file
*
* Pre-condition:	A file has been chosen by the user and its name 
* shows on the file name field
* 
* Post-condition:	The OK button will be disabled in case it is 
* 					not a site.xml file, otherwise it will be enabled  
*
* DEPRECATED: we use the validation method of dijit.form.ValidationTextBox
**************************************************************/
function checkForSiteXML() {
	
	var siteFile = dijit.byId('internalFile').textbox.value;
	var siteName = dijit.byId('sitename').textbox.value;
	
	// If not modified, return
	if (!isSiteinfoModified(siteName, siteFile)) {
		
		setAttribute('okSiteXMLUploadButton', 'disabled', true);
		setContent('siteXMLWarning', '');
		return;
	}
	
	// We expect a filename to be site.xml
	var siteXML = new RegExp("/site.xml");
	
	siteFile = siteFile.replace(/\\/g, '/');
	
	// Check if a site.xml file has been selected
 	var isSiteXMLFile = siteXML.test(siteFile);
	
	// If site.xml file is selected, enable the OK button & hide the alert message
	if(isSiteXMLFile) {
		setAttribute('okSiteXMLUploadButton', 'disabled', false);
		var content = '';
		if (/*location.hostname == "127.0.0.1" && */siteFile == "C:/fakepath/site.xml" && isIE8()) {
			content = '<img src="css/icons/so_warning_v.gif" alt=""/><label>' 
				+ siteXMLWarninglbl_msg 
				+ '</label><button dojoType="dijit.form.Button" showLabel="false" iconClass="UA_Icons help" style="alignment:right;" onclick="showIEFakepathHelp()">' 
				+ helplbl_msg
				+ '</button>';
		}
		setContent('siteXMLWarning', content);
	}
	// Otherwise, disable OK button & show the warning
	else {
		setAttribute('okSiteXMLUploadButton', 'disabled', true);
		var content = '<img src="css/icons/so_critical_v.gif" alt=""/>' 
			+ siteXMLErrorlbl_msg;
		setContent('siteXMLWarning', content);
	}
}

function checkForSiteName() {
	
	var siteFile = dijit.byId('internalFile').textbox.value;
	var siteName = dijit.byId('sitename').textbox.value;
	
	setAttribute('okSiteXMLUploadButton', 'disabled', !isSiteinfoModified(siteName, siteFile));
}

function isSiteinfoModified(siteName, siteFile) {
	
	var isLocalType = dijit.byId("localType").getValue();
	
	return !(siteFile == "" || siteFile == "http://" 
		|| (IS_VIEW_EDIT_MODE == true 
			&& ((VIEW_SITE_TYPE == isLocalType) || (VIEW_SITE_TYPE == true && isLocalType != false)) 
			&& siteName == VIEW_SITE_NAME 
			&& siteFile == VIEW_SITE_PATH));
}

/**************************************************************
 * Adds a new local update site. The site is local to the location
 * where this webapp is deployed
 **************************************************************/
function addLocalEntryFromId() {

	destroyLocalTooltip();
	
	// If not modified, return
	if (!isSiteinfoModified()) {
		
		resetDialog();
		return;
	}
	
	var siteName = dojo.byId('sitename').value;
//	var siteFile = readSiteXMLFullFileName();
	
	var siteFile = dijit.byId('internalFile').value;
	
	if (IS_VIEW_EDIT_MODE == true) {
		updateLocalEntry(siteName, siteFile, VIEW_SITE_PATH);
	} else if (siteFile != "" && siteFile != "http://") {
		addLocalEntry(siteName, siteFile);
	}
	
	resetDialog();
}

function resetDialog() {
	
	var title = addSitelbl_msg;
	setSiteDialog(title, '', true, '');
	IS_VIEW_EDIT_MODE = false;
	dojo.byId("helpButton").style.display = 'none';
}

function createLocalTooltip() {
	
	var tooltipLabel = "<table width=\'285px\' cellpadding=0 cellspacing=0><tr><td align=\'left\'><b>Local</b></td></tr><tr><td align=\'left\'><ul><li>Provide the path of the <b><font color=\'#000080\'>site.xml</font></b> file available locally</li></ul></td></tr></table>";
	createTooltipById('local_tooltip', tooltipLabel, 'localType');
}

function destroyLocalTooltip() {
	
	destroyTooltipById('local_tooltip');
}

function handleLocalCancel() {
	
	destroyLocalTooltip();
	resetDialog();
}

function addLocalFile() {
	
	var fileBrowser = dijit.byId('localFile');
	
	var siteFile = fileBrowser.getValue();
	
	var fileTextBox = dijit.byId('internalFile');
	if (siteFile != "" && fileTextBox) {
		fileTextBox.focus();
		fileTextBox.setValue(siteFile);
	}
}

function updateSiteDialog(siteName, isLocalType/* , readOnly */, value) {
	
	dojo.byId('sitename').value = siteName;
	setAttribute('localType', 'checked', isLocalType);
	setAttribute('remoteType', 'checked', !isLocalType);
//	dojo.byId('internalFile').readOnly = isLocalType; // readOnly;
	dijit.byId('internalFile').setValue(value);
	
	updateFileSelectionControl(isLocalType);
	
	// If not modified, return
	if (!isSiteinfoModified(siteName, value))
		setAttribute('okSiteXMLUploadButton', 'disabled', true);
	else
		setAttribute('okSiteXMLUploadButton', 'disabled', !dijit.byId("internalFile").isValid());
//	setContent('siteXMLWarning', '');
}

function updateFileSelectionControl(isLocalType) {
	
	var localFile = dijit.byId("localFile");
	if (localFile) {
		dojo.byId("localFilePane").removeChild(localFile.domNode);
		localFile.destroy();
	}
	
	if (isLocalType)
		setContent('localFilePane', 
			'<input id="localFile" name="localFile" type="file" dojoType="ibm.widget.FileInput" />');
}

function setSiteDialog(title, siteName, isLocalType/* , readOnly */, value) {
	
	VIEW_SITE_NAME = siteName;
	VIEW_SITE_PATH = value;
	VIEW_SITE_TYPE = isLocalType;
	
	dijit.byId("optionsDialog").titleNode.innerHTML = title || "";
	
	updateSiteDialog(VIEW_SITE_NAME, VIEW_SITE_TYPE, VIEW_SITE_PATH);
}

function setViewEditSiteDialog(siteName, isLocalType, value) {
	
	var title = viewEditSitelbl_msg;
	setSiteDialog(title, siteName, isLocalType, value);
	setAttribute('okSiteXMLUploadButton', 'disabled', !dijit.byId("internalFile").isValid());
//	setAttribute('okSiteXMLUploadButton', 'disabled', false);		
	IS_VIEW_EDIT_MODE = true;
}
